{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "filterbyname",
            "doc": "Filterbyname",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bbmap:38.96--h5c4e2a8_1",
                    "id": "#bbmap-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "bbmap",
                            "version": [
                                "38.96"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/bbmap"
                            ]
                        }
                    ],
                    "id": "#bbmap-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "in=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/in"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "in2=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/in2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "include=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/include"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "names=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/names"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "out=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/out"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "out2=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/out2"
                }
            ],
            "baseCommand": [
                "filterbyname.sh"
            ],
            "id": "#filterbyname.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://bowtie-bio.sourceforge.net/index.shtml",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out)"
                    },
                    "id": "#filterbyname.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.out2)"
                    },
                    "id": "#filterbyname.cwl/output2"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "doc": "BASH echo command",
            "label": "FastQC",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": "$(inputs.threads)",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/fastqc:0.11.9--hdfd78af_1",
                    "id": "#fastqc-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "fastqc",
                            "version": [
                                "0.11.9"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/fastqc"
                            ]
                        }
                    ],
                    "id": "#fastqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#fastqc.cwl/fastq"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-t"
                    },
                    "id": "#fastqc.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.html"
                    },
                    "id": "#fastqc.cwl/out_html"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.zip"
                    },
                    "id": "#fastqc.cwl/out_zip"
                }
            ],
            "baseCommand": [
                "fastqc",
                "--outdir",
                ".",
                "--extract"
            ],
            "id": "#fastqc.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "extract_foreign_contaminated_ids",
            "doc": "This tools remove contaminated reads from fastq using blastn results from Gtax TSV file",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                },
                {
                    "dockerImageId": "cwl-ngs-workflows-cbb-transcriptome-contamination-detection:3.7",
                    "dockerFile": "# Base Image\nFROM quay.io/biocontainers/python:3.7\n\n# Metadata\nLABEL base.image=\"quay.io/biocontainers/python:3.7\"\nLABEL version=\"1\"\nLABEL software=\"Python3\"\nLABEL software.version=\"3.7\"\nLABEL description=\"Python based docker image\"\nLABEL tags=\"Python\"\n\n# Maintainer\nMAINTAINER Roberto Vera Alvarez <r78v10a07@gmail.com>\n\nUSER root\n# Adding Python packages\nRUN python -m pip install \\\n    biopython==1.79  \\\n    networkx==2.5.1 \\\n    pandas==1.3.4\n",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "package": "pandas",
                            "version": [
                                "1.3.4"
                            ],
                            "specs": [
                                "https://anaconda.org/conda-forge/pandas"
                            ]
                        },
                        {
                            "package": "biopython",
                            "version": [
                                "1.79"
                            ],
                            "specs": [
                                "https://anaconda.org/conda-forge/biopython"
                            ]
                        },
                        {
                            "package": "networkx",
                            "version": [
                                "2.5.1"
                            ],
                            "specs": [
                                "https://anaconda.org/conda-forge/networkx"
                            ]
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "requirements": [
                {
                    "listing": [
                        {
                            "entryname": "extract_foreign_contaminated_ids.py",
                            "entry": "import os\nimport sys\nimport pandas\nimport gzip\nimport pickle\nimport networkx as nx\nfrom Bio import SeqIO\nfrom multiprocessing import Pool\n\nfile_name_prefix = sys.argv[1]\npartitions = int(sys.argv[2])\nthreads = int(sys.argv[3])\ntax_group_pickle = sys.argv[4]\ntax_group = sys.argv[5]\ndata_dir = sys.argv[6]\n\ntax_groups = pickle.load(open(tax_group_pickle, \"rb\"))\n\nnum_files = len([f for dr, ds, files in os.walk(data_dir) for f in files if f.endswith('.fsa.gz')])\n\ndef find_decont_reads(p):\n    transcripts = set()\n    with gzip.open(os.path.join(data_dir, '{}_{}.fsa.gz'.format(file_name_prefix, p)), 'rt') as fin:\n        for r in SeqIO.parse(fin, \"fasta\"):\n            transcripts.add(r.id)\n    file_name = os.path.join(data_dir, '{}_{}_contamination_{}_blastn.tsv'.format(file_name_prefix, p, 1))\n    df = pandas.read_csv(file_name, sep='\\t', header=None,\n                         names=['qseqid', 'sseqid', 'pident', 'length', 'mismatch', 'gapopen',\n                                'qlen', 'qstart', 'qend', 'sstart', 'send', 'evalue',\n                                'bitscore', 'score', 'taxid'])\n    for i in range(2, partitions + 1):\n        file_name = os.path.join(data_dir, '{}_{}_contamination_{}_blastn.tsv'.format(file_name_prefix, p, i))\n        if os.path.exists(file_name):\n            df_tmp = pandas.read_csv(file_name, sep='\\t', header=None,\n                                     names=['qseqid', 'sseqid', 'pident', 'length', 'mismatch', 'gapopen',\n                                            'qlen', 'qstart', 'qend', 'sstart', 'send', 'evalue',\n                                            'bitscore', 'score', 'taxid'])\n            df = pandas.concat([df, df_tmp])\n    df['coverage'] = df['length']*100/df['qlen']\n    df = df[df['coverage'] >= 75]\n    ids = df[df['taxid'].isin(tax_groups[tax_group]['nodes'])]['qseqid'].unique()\n    df = df[~df['qseqid'].isin(ids)]\n    print('{} done'.format(p))\n    return transcripts.difference(set(df['qseqid'].unique()))\n\np = Pool(processes=threads)\nresults = p.map(find_decont_reads, [t for t in range(1, num_files + 1)])\np.close()\n\ntranscripts_ids = set()\nfor r in results:\n    transcripts_ids.update(r)\n    print('{}'.format(len(transcripts_ids)))\n\nprint('Printing file: {}_clean_reads.tsv'.format(file_name_prefix))\nwith open('{}_clean_reads.tsv'.format(file_name_prefix), 'w') as fout:\n    for t in transcripts_ids:\n        fout.write(t + '\\n')\n"
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": "$(inputs.threads)",
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#extract-clean-from-foreign-blastn.cwl/data_dir"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#extract-clean-from-foreign-blastn.cwl/file_name_prefix"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#extract-clean-from-foreign-blastn.cwl/partitions"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#extract-clean-from-foreign-blastn.cwl/tax_group"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#extract-clean-from-foreign-blastn.cwl/tax_group_pickle"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#extract-clean-from-foreign-blastn.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.file_name_prefix)_clean_reads.tsv"
                    },
                    "id": "#extract-clean-from-foreign-blastn.cwl/output"
                }
            ],
            "baseCommand": [
                "python",
                "extract_foreign_contaminated_ids.py"
            ],
            "id": "#extract-clean-from-foreign-blastn.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "label": "fastq_foreign_chromosome_cleanup",
            "doc": "This workflow remove foreign chromosome comtamination from blastn TSV files",
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/data_dir"
                },
                {
                    "type": "File",
                    "id": "#main/fastq1"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/fastq2"
                },
                {
                    "type": "string",
                    "id": "#main/file_name_prefix"
                },
                {
                    "type": "int",
                    "id": "#main/partitions"
                },
                {
                    "type": "string",
                    "id": "#main/tax_group"
                },
                {
                    "type": "File",
                    "id": "#main/tax_group_pickle"
                },
                {
                    "type": "int",
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/extract_clean_reads_ids/output",
                    "type": "File",
                    "id": "#main/decontaminated_reads_ids"
                },
                {
                    "outputSource": "#main/create_clean_fastq/output",
                    "type": "File",
                    "id": "#main/fastq1_output"
                },
                {
                    "outputSource": "#main/create_clean_fastq/output2",
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/fastq2_output"
                },
                {
                    "outputSource": "#main/fastqc1/out_html",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastqc1_html"
                },
                {
                    "outputSource": "#main/fastqc1/out_zip",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastqc1_zip"
                },
                {
                    "outputSource": "#main/fastqc2/out_html",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#main/fastqc2_html"
                },
                {
                    "outputSource": "#main/fastqc2/out_zip",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#main/fastqc2_zip"
                }
            ],
            "steps": [
                {
                    "label": "Creates clean FASTQ",
                    "run": "#filterbyname.cwl",
                    "in": [
                        {
                            "source": "#main/fastq1",
                            "id": "#main/create_clean_fastq/in"
                        },
                        {
                            "source": "#main/fastq2",
                            "id": "#main/create_clean_fastq/in2"
                        },
                        {
                            "default": "t",
                            "id": "#main/create_clean_fastq/include"
                        },
                        {
                            "source": "#main/extract_clean_reads_ids/output",
                            "id": "#main/create_clean_fastq/names"
                        },
                        {
                            "valueFrom": "${\n   var nameroot = inputs.in.nameroot;\n   if (nameroot.endsWith(\".fastq\")){\n     nameroot = nameroot.replace(\".fastq\", \"\");\n   }else if (nameroot.endsWith(\".fq\")){\n     nameroot = nameroot.replace(\".fq\", \"\");\n   }\n   if (nameroot.endsWith(\"_1\")){\n     nameroot = nameroot.replace('_1', '_foreign_1.fastq.gz');\n   }else if (nameroot.includes(\"_R1_\")){\n     nameroot = nameroot.substring(1, nameroot.indexOf(\"_R1_\")) + '_foreign_1.fastq.gz';\n   } else{\n     nameroot = nameroot + '_foreign.fastq.gz';\n   }\n   return nameroot;\n}\n",
                            "id": "#main/create_clean_fastq/out"
                        },
                        {
                            "valueFrom": "${\n    if (inputs.in2 != null){\n       var nameroot = inputs.in2.nameroot;\n       if (nameroot.endsWith(\".fastq\")){\n         nameroot = nameroot.replace(\".fastq\", \"\");\n       }else if (nameroot.endsWith(\".fq\")){\n         nameroot = nameroot.replace(\".fq\", \"\");\n       }\n       if (nameroot.endsWith(\"_2\")){\n         nameroot = nameroot.replace('_2', '_foreign_2.fastq.gz');\n       }else if (nameroot.includes(\"_R2_\")){\n         nameroot = nameroot.substring(1, nameroot.indexOf(\"_R2_\")) + '_foreign_2.fastq.gz';\n       }\n       return nameroot;\n    }\n    return null;\n}\n",
                            "id": "#main/create_clean_fastq/out2"
                        }
                    ],
                    "out": [
                        "#main/create_clean_fastq/output",
                        "#main/create_clean_fastq/output2"
                    ],
                    "id": "#main/create_clean_fastq"
                },
                {
                    "label": "Extract decontaminated reads IDs",
                    "run": "#extract-clean-from-foreign-blastn.cwl",
                    "in": [
                        {
                            "source": "#main/data_dir",
                            "id": "#main/extract_clean_reads_ids/data_dir"
                        },
                        {
                            "source": "#main/file_name_prefix",
                            "id": "#main/extract_clean_reads_ids/file_name_prefix"
                        },
                        {
                            "source": "#main/partitions",
                            "id": "#main/extract_clean_reads_ids/partitions"
                        },
                        {
                            "source": "#main/tax_group",
                            "id": "#main/extract_clean_reads_ids/tax_group"
                        },
                        {
                            "source": "#main/tax_group_pickle",
                            "id": "#main/extract_clean_reads_ids/tax_group_pickle"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/extract_clean_reads_ids/threads"
                        }
                    ],
                    "out": [
                        "#main/extract_clean_reads_ids/output"
                    ],
                    "id": "#main/extract_clean_reads_ids"
                },
                {
                    "run": "#fastqc.cwl",
                    "label": "fastqc",
                    "in": [
                        {
                            "source": "#main/create_clean_fastq/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/fastqc1/fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/fastqc1/threads"
                        }
                    ],
                    "out": [
                        "#main/fastqc1/out_html",
                        "#main/fastqc1/out_zip"
                    ],
                    "id": "#main/fastqc1"
                },
                {
                    "run": "#fastqc.cwl",
                    "when": "$(inputs.fastq[0] != null)",
                    "label": "fastqc",
                    "in": [
                        {
                            "source": "#main/create_clean_fastq/output2",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/fastqc2/fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/fastqc2/threads"
                        }
                    ],
                    "out": [
                        "#main/fastqc2/out_html",
                        "#main/fastqc2/out_zip"
                    ],
                    "id": "#main/fastqc2"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.2",
    "$schemas": [
        "https://schema.org/version/latest/schemaorg-current-http.rdf"
    ]
}
